//+------------------------------------------------------------------+
//|                                          optimal tracking filter |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int    Price              = PRICE_MEDIAN;
extern int    PriceToCompareTo   = PRICE_CLOSE;
extern int    Passes             = 1;
extern bool   InheritedHighLow   = false;

//
//
//
//
//

double otf[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,trend);
   SetIndexBuffer(1,otf);
   
      string PriceType;
         switch(Price)
         {
            case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
            case PRICE_OPEN:     PriceType = "Open";     break;  // 1
            case PRICE_HIGH:     PriceType = "High";     break;  // 2
            case PRICE_LOW:      PriceType = "Low";      break;  // 3
            case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
            case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
            case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
         }      

   //
   //
   //
   //
   //

   IndicatorShortName("Optimal tracking filter ("+PriceType+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double buff[][100];
#define _prc  0
#define _tmp1 1
#define _tmp2 2
#define _otf  3

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

      if (ArrayRange(buff,0) != Bars) ArrayResize(buff,Bars);
      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         switch (Price)
         {
            case 7 :  buff[r][_prc] = (Open[i]+Close[i])/2.0;                break;
            case 8 :  buff[r][_prc] = (Open[i]+Close[i]+High[i]+Low[i])/4.0; break;
            default : buff[r][_prc] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         }
      
         //
         //
         //
         //
         //

            for(int k=0; k<Passes; k++)
            {
               buff[r][_tmp1+k*4] = 0.2*(buff[r][_prc+k*4]-buff[r-1][_prc+k*4])+0.8*buff[r-1][_tmp1+k*4];
               if (InheritedHighLow)
                     if (k==0)
                           buff[r][_tmp2+k*4] = 0.1*(High[i]-Low[i])      +0.8*buff[r-1][_tmp2+k*4];
                     else  buff[r][_tmp2+k*4] = 0.1*buff[r][_tmp2+(k-1)*4]+0.8*buff[r-1][_tmp2+k*4];
               else  buff[r][_tmp2+k*4] = 0.1*(High[i]-Low[i])+0.8*buff[r-1][_tmp2+k*4];
               
               //
               //
               //
               //
               //
               
               if (buff[r][_tmp2+k*4]!=0)
                     double lambda = MathAbs(buff[r][_tmp1+k*4]/buff[r][_tmp2+k*4]);
               else         lambda = 0;
               double alpha = ( -lambda*lambda + MathSqrt(lambda*lambda*lambda*lambda + 16.0*lambda*lambda))/8.0;
                  buff[r][_otf+k*4] = buff[r-1][_otf+k*4]+alpha*(buff[r][_prc+k*4]-buff[r-1][_otf+k*4]);
            
               //
               //
               //
               //
               //
            
               if (k<(Passes-1)) buff[r][_prc+(k+1)*4] = buff[r][_otf+k*4];
            }            
            otf[i] = buff[r][_otf+(Passes-1)*4];

         //
         //
         //
         //
         //

         trend[i] = trend[i+1];

         //
         //
         //
         //
         //
         
         double price;
         switch (PriceToCompareTo)
         {
            case 7 :  price = (Open[i]+Close[i])/2.0;                break;
            case 8 :  price = (Open[i]+Close[i]+High[i]+Low[i])/4.0; break;
            default : price = iMA(NULL,0,1,0,MODE_SMA,PriceToCompareTo,i);
         }
         if (price > otf[i]) trend[i] =  1;
         if (price < otf[i]) trend[i] = -1;
      }
      return(0);
}